var DISClientBuilder = require('./src/index');

var RecordsStub = require('./src/stub/Records');
var CONF = {
  PROJECTID: '43e2c9ac4e8b4c6d9d751a2c8a230a8c',
  REGIONNAME: 'cn-north-7',
  AK: 'YOUR_AK',
  SK: 'YOUR_SK'
};

process.env.NODE_TLS_REJECT_UNAUTHORIZED = '0';

var STREAM_NAME = 'fangzhirui11';

var api = DISClientBuilder.buildRecordApi(CONF);
var putRecordsRequest = RecordsStub.mockPutRecordsRequest(STREAM_NAME);

var partitionId = 'shardId-0000000000';

function recursiveGetRecords(p, partition_cursor) {
  if(arguments.length === 1){
    partition_cursor = p;
  }
  p = new Promise(function (resolve, reject) {
    api.getRecords(CONF.PROJECTID, partition_cursor, function (error, data, response) {
      if (error) {
        console.error('[INFO] error => ' + error);
        console.error('[INFO] error details => ' + response.text);
        console.error('[INFO] http code => ' + response.status);
        reject(error);
      } else {
        data.records.forEach(function (record) {
          record.data = Buffer.from(record.data, 'base64').toString();
        });
        console.log('[INFO] data => ' + JSON.stringify(data));
        console.log('[INFO] http code => ' + response.status);
        if(data.records && (data.records.length !== 0)){
          resolve(data.next_partition_cursor);
        } else {
          reject('[INFO] Cursor moved to the end of partition.');
        }
      }
    });
  });
  p.then(function (partition_cursor) {
    recursiveGetRecords(p, partition_cursor);
  }).catch(function (error) {
    console.log(error);
  });
}

api.getCursor(CONF.PROJECTID, STREAM_NAME, partitionId, {
  cursorType: 'AT_SEQUENCE_NUMBER',
  startingSequenceNumber: '420'
}, function (error, data, getCursorResponse) {
  if (error) {
    console.error('[error] error => ' + error);
    console.error('[error] error details => ' + getCursorResponse.text);
    console.error('[error] http code => ' + getCursorResponse.status);
  } else {
    recursiveGetRecords(data.partition_cursor);
  }
});
